## kmer-tools 0~20150903+r2013

=== Makefile ===
# -*- makefile -*-

### NOTE: make-3.80 has a bug in eval which causes it not to return
###   an empty target, but instead it sometimes returns very weird
###   stuff that makes make segv, I think.
### You need to get it patched at:
### http://savannah.gnu.org/bugs/?func=detailbug&bug_id=1517&group_id=71

default:   all

MAKEFILE/ :=$(dir $(firstword $(MAKEFILE_LIST)))

ifneq ($(shell ls -d ${MAKEFILE/}/Make.compilers 2> /dev/null), ${MAKEFILE/}/Make.compilers)
  MAKECOMPILERSNOTHING := $(shell ${MAKEFILE/}configure.sh)
endif

include ${MAKEFILE/}Make.compilers


##### non-recursive make magic
# all directories which have been included
//           :=
# current path (empty)
/            :=

# recursive directories to be filtered out of //
# and handled differently
//-RECURSIVE    :=
define MakeRecursive
//-RECURSIVE :=$$/.
endef

## Include -hack
# Include is wrapped in something which will push and pop /
# properly while adding newly discovered directories to //
# and keeping track of who is who's children (.SUBS).
#
# Each directory so included has its Make.include file included.
# Those Make.include files can use $/ prepended to local names
# to prevent name pollution, and define their own subtargets.
#
define Include
 $(foreach x,$(strip ${1}),$(call Include_File,$x))
endef

define Include_File
  ifeq ($(filter ${1}.,${WITHOUT_}),)
    ifeq ($(wildcard ${1}Make.include),${1}Make.include)
      $/.SUBS +=${1}.
      // +=${1}.
      ${1}.SUBS :=
      /  :=${1}
      include ${1}Make.include
      /  :=$/
    endif
  endif

endef

##### System specific includes

## WITHOUT
# If the user specifies a WITHOUT, then those paths are not
# followed.
ifndef WITHOUT
  WITHOUT:=
endif
WITHOUT_:=$(patsubst %,%.,$(strip ${WITHOUT}))

## First Make.include inclusion
# invoke the toplevel include file.
# We use 'Include_File' instead of 'Include' since $/ is empty
$(eval $(call Include_File,$/))

#### Targets which have been declared RECURSIVE are removed
# from // and processed separately.
//            :=$(filter-out ${//-RECURSIVE},${//})

# //-RECURSIVE now holds the paths which are being done legacy style
# and // holds the paths which are going to be part of the system.

### Building subgoals in Make.rules
# subgoals and depends are done with the deferred '=' not the ':='.
# This is because we want dynamic scoping.
__SUBGOALS__=
__DEPGOALS__=

-include ${MAKEFILE/}Make.rules

# now we bring in the depends files as defined by the Includes
# and the patterns in Make.rules
$(eval DEPENDS:=$(foreach x,${//},$(call __DEPGOALS__,$x)))
ifneq ($(strip ${DEPENDS}),)
  # this conditional gets us a way out if things go way wrong
  ifeq ($(filter %-clean,${MAKECMDGOALS}),)
    -include ${DEPENDS} 
  endif
endif

### the standard make targets, applied to all subdirectory targets
# We define the basic form of the all, clean, ... rules on a
# per-path basis (the $/.all, $..clean, ... targets).  This allows
# selective targeting.
## rules for each subtarget
#  current subtargets are :
#        all, ls, clean, real-clean, depends-clean, install
#  with all, clean, real-clean, install being required targets
#  of recursive makes.

clean:         ${//-RECURSIVE:.=.clean}      $/.clean
define .RULE-clean
${1:.=.clean}: $${${1:.=.SUBS}:.=.clean}
	${RM} $${${1:.=.CLEAN}} ${__SUBGOALS__}
ifneq ($(strip ${C_TMP_COMPILE} ${CXX_TMP_COMPILE}),)
	(cd $1 && ${RM} -r ${C_TMP_COMPILE} ${CXX_TMP_COMPILE})
endif

endef
$(eval $(foreach x,${//},$(call .RULE-clean,$x)))


depends-clean:                            $/.depends-clean
${//-RECURSIVE:.=.depends-clean}:
define .RULE-depends-clean
${1:.=.depends-clean}: $${${1:.=.SUBS}:.=.depends-clean}
	${RM} ${1:.=Make.depends} ${__DEPGOALS__}

endef
$(eval $(foreach x,${//},$(call .RULE-depends-clean,$x)))

real-clean:    ${//-RECURSIVE:.=.real-clean} $/.real-clean
define .RULE-real-clean
${1:.=.real-clean}: $${${1:.=.SUBS}:.=.real-clean}
	${RM} $${${1:.=.CLEAN}} ${__SUBGOALS__} ${1:.=Make.depends} ${__DEPGOALS__} $${${1:.=.REAL-CLEAN}}
#ifneq ($(strip ${INSTALL/}),)
#	${RM} -r ${INSTALL/}
#endif
ifneq ($(strip ${C_TMP_COMPILE} ${CXX_TMP_COMPILE}),)
	(cd $1 && ${RM} -r ${C_TMP_COMPILE} ${CXX_TMP_COMPILE})
endif

endef
$(eval $(foreach x,${//},$(call .RULE-real-clean,$x)))

all:           ${//-RECURSIVE:.=.all}        $/.all
define .RULE-all
${1:.=.all}: $${${1:.=.SUBS}:.=.all} ${__SUBGOALS__}

endef
$(eval $(foreach x,${//},$(call .RULE-all,$x)))

## INSTALL:
# Define targets which give a basic recursive traversal to hang
# things from for anything install related that I haven't thought of

# this does the copy part of the install
${//-RECURSIVE:.=.install-copy}:
install-copy:       ${//-RECURSIVE:.=.install-copy}    $/.install-copy
define .RULE-install-copy
${1:.=.install-copy}: $${${1:.=.SUBS}:.=.install-copy}

endef
$(eval $(foreach x,${//},$(call .RULE-install-copy,$x)))

# define the actual install target as being a combination of the
# all target plus the pre-/install-copy targets

install:       ${//-RECURSIVE:.=.install}    $/.install
define .RULE-install
${1:.=.install}: ${1:.=.all} ${1:.=.install-copy}

endef
$(eval $(foreach x,${//},$(call .RULE-install,$x)))



# a sort of debugging thing.  Let's me check on which targets
# actually didn't get made, or got partially made
LSOPTS:=-l
ls:                                       $/.ls
${//-RECURSIVE:.=.ls}:
define .RULE-ls
${1:.=.ls}: $${${1:.=.SUBS}:.=.ls}
	@ files='$$(strip ${__SUBGOALS__})'; \
	  if [ -n "$$$${files}" ] ; then \
	    ls ${LSOPTS} $$$${files} ; \
	  fi ; exit 0;

endef
$(eval $(foreach x,${//},$(call .RULE-ls,$x)))

=== libbio/test/Makefile ===


#PROG    = test-merstream-from-seqstore

PROG    = dump-merstreamfile \
          test-seqStream \
          test-chainedSequence \
          test-fasta-accessor \
          test-merstream \
          test-merstreamfile \
          test-setbits \
          halign-test

DEAD =    test-merstream-speed \
          test-bigmer-msf \


INCLUDE = -I.. -I../../libutil
LIBS    = -L.. -L../../libutil -lbio -lutil -lm
OBJS    = 

include ../../Make.compilers

all: $(PROG)
	@echo Tests passed!

dump-merstreamfile: dump-merstreamfile.C
	$(CXX) $(CXXFLAGS_COMPILE) -c -o dump-merstreamfile.o dump-merstreamfile.C $(INCLUDE)
	$(CXX) $(CXXLDFLAGS) -o dump-merstreamfile dump-merstreamfile.o $(LIBS)

test-merstream-from-seqstore: test-merstream-from-seqstore.C
	$(CXX) $(CXXFLAGS_COMPILE) -c -o test-merstream-from-seqstore.o test-merstream-from-seqstore.C $(INCLUDE)
	$(CXX) $(CXXLDFLAGS) -o test-merstream-from-seqstore test-merstream-from-seqstore.o $(LIBS)

test-seqStream: test-seqStream.C
	$(CXX) $(CXXFLAGS_COMPILE) -c -o test-seqStream.o test-seqStream.C $(INCLUDE)
	$(CXX) $(CXXLDFLAGS) -o test-seqStream test-seqStream.o $(LIBS)
	../../leaff/leaff -G 3 30 40 > junk2.fasta
	./test-seqStream junk2.fasta
	rm -f junk*

test-chainedSequence: test-chainedSequence.C
	$(CXX) $(CXXFLAGS_COMPILE) -c -o test-chainedSequence.o test-chainedSequence.C $(INCLUDE)
	$(CXX) $(CXXLDFLAGS) -o test-chainedSequence test-chainedSequence.o $(LIBS)
	./test-chainedSequence
	../../leaff/leaff -G 1000 1000 3000 > junk2.fasta
	./test-chainedSequence junk2.fasta
	rm -f junk*

test-fasta-accessor: test-fasta-accessor.C
	$(CXX) $(CXXFLAGS_COMPILE) -c -o test-fasta-accessor.o test-fasta-accessor.C $(INCLUDE)
	$(CXX) $(CXXLDFLAGS) -o test-fasta-accessor test-fasta-accessor.o $(LIBS)
	./test-fasta-accessor

test-merstream: test-merstream.C
	$(CXX) $(CXXFLAGS_COMPILE) -c -o test-merstream.o test-merstream.C $(INCLUDE)
	$(CXX) $(CXXLDFLAGS) -o test-merstream test-merstream.o $(LIBS)
	../../leaff/leaff -G 1 10000 30000 > junk.fasta
	./test-merstream junk.fasta
	rm -f junk*
	../../leaff/leaff -G 1000 10000 30000 > junk.fasta
	./test-merstream junk.fasta
	rm -f junk*

test-merstreamfile: test-merstreamfile.C
	$(CXX) $(CXXFLAGS_COMPILE) -c -o test-merstreamfile.o test-merstreamfile.C $(INCLUDE)
	$(CXX) $(CXXLDFLAGS) -o test-merstreamfile test-merstreamfile.o $(LIBS)
	#../../leaff/leaff -G 2 50 50 > junk.fasta
	../../leaff/leaff -G 100000 10 600 > junk.fasta
	#../../leaff/leaff -G 10000 10 10000 > junk.fasta
	#../../leaff/leaff -G 30000 10000 10000 > junk.fasta
	./test-merstreamfile junk.fasta
	#rm -f junk.fasta junk.fastaidx

test-merstream-speed: test-merstream-speed.C
	$(CXX) $(CXXFLAGS_COMPILE) -c -o test-merstream-speed.o test-merstream-speed.C $(INCLUDE)
	$(CXX) $(CXXLDFLAGS) -o test-merstream-speed test-merstream-speed.o $(LIBS)
	../../leaff/leaff -G 10000 1000 10000 > junk.fasta
	cat junk.fasta > /dev/null
	./test-merstream-speed junk.fasta
	rm -f junk*

test-setbits: test-setbits.C
	$(CXX) $(CXXFLAGS_COMPILE) -c -o test-setbits.o test-setbits.C $(INCLUDE)
	$(CXX) $(CXXLDFLAGS) -o test-setbits test-setbits.o $(LIBS)
	./test-setbits

test-bigmer-msf: test-bigmer-msf.C
	$(CXX) $(CXXFLAGS_COMPILE) -c -o test-bigmer-msf.o test-bigmer-msf.C $(INCLUDE)
	$(CXX) $(CXXLDFLAGS) -o test-bigmer-msf test-bigmer-msf.o $(LIBS)
	./test-bigmer-msf

halign-test: halign-test.C
	$(CXX) $(CXXFLAGS_COMPILE) -c -o halign-test.o halign-test.C $(INCLUDE)
	$(CXX) $(CXXLDFLAGS) -o halign-test halign-test.o $(LIBS)

clean:
	rm -f $(PROG) *.o *junk*

=== snapper/test/Makefile ===



all:
	@../../leaff/leaff -G 1 2000 2000 > 1.f
	@../../leaff/leaff -G 1  700  700 > 2.f
	@../../leaff/leaff -G 1 3000 3000 > 3.f
	@echo ">g1" > g.f
	@cat 1.f 2.f 3.f | grep -v '>' >> g.f
	@echo ">g2" >> g.f
	@cat 3.f 2.f 1.f | grep -v '>' >> g.f
	@echo ">g3" >> g.f
	@cat 1.f 2.f 3.f | grep -v '>' >> g.f
	@rm -f 1.f 3.f
	../snapper2 -mersize 23 -queries 2.f -genomic g.f -output x.out
	@cat x.out
	@echo ""
	@echo "Check that the ranges are 1900-2800, 2900-3800 and 1900-2800"
	@echo "Check that ddefs change"
	@echo "Check that exons are the same"
	@rm -f 1.f* 2.f* 3.f* g.f* x.tmp* x.out*

## kmer-tools 0~20150520+2004

=== debian/changelog ===
kmer-tools (0~20150520+2004-1) unstable; urgency=low

  * Initial release (Closes: #784863)

 -- Afif Elghraoui <afif@ghraoui.name>  Fri, 01 May 2015 19:20:00 -0700

=== debian/control ===
Source: kmer-tools
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Afif Elghraoui <afif@ghraoui.name>
Build-Depends: debhelper (>= 9),
	       libbz2-dev
Standards-Version: 3.9.6
Homepage: http://kmer.sourceforge.net
Vcs-Git: git://anonscm.debian.org/debian-med/kmer-tools.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-med/kmer-tools.git

Package: kmer
Architecture: any
Depends: ${shlibs:Depends},
	 ${misc:Depends},
	 meryl
Description: suite of tools for DNA sequence analysis
 The kmer package is a suite of tools for DNA sequence analysis.
 It provides tools for searching (ESTs, mRNAs, sequencing reads);
 aligning (ESTs, mRNAs, whole genomes); and a variety of analyses
 based on kmers.
 .
 This is a metapackage depending on the executable components of the kmer suite.

Package: libkmer-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
	 ${misc:Depends},
	 libmeryl-dev
Description: suite of tools for DNA sequence analysis (development lib)
 The kmer package is a suite of tools for DNA sequence analysis.
 It provides tools for searching (ESTs, mRNAs, sequencing reads);
 aligning (ESTs, mRNAs, whole genomes); and a variety of analyses
 based on kmers.
 .
 This is a metapackage package depending on the development components of kmer.

Package: meryl
Architecture: any
Depends: ${shlibs:Depends},
	 ${misc:Depends}
Description: in- and out-of-core kmer counting and utilities
 meryl computes the kmer content of genomic sequences.  Kmer
 content is represented as a list of kmers and the number of
 times each occurs in the input sequences.  The kmer can be
 restricted to only the forward kmer, only the reverse kmer,
 or the canonical kmer (lexicographically smaller of the
 forward and reverse kmer at each location).  Meryl can
 report the histogram of counts, the list of kmers and their
 counts, or can perform mathematical and set operations
 on the processed data files.

Package: libmeryl-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
	 ${misc:Depends}
Description: in- and out-of-core kmer counting and utilities (development lib)
 meryl computes the kmer content of genomic sequences.  Kmer
 content is represented as a list of kmers and the number of
 times each occurs in the input sequences.  The kmer can be
 restricted to only the forward kmer, only the reverse kmer,
 or the canonical kmer (lexicographically smaller of the
 forward and reverse kmer at each location).  Meryl can
 report the histogram of counts, the list of kmers and their
 counts, or can perform mathematical and set operations
 on the processed data files.
 .
 This package contains the static libraries and header files.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# The custom build system doesn't support CPPFLAGS
CFLAGS:=$(CPPFLAGS) $(CFLAGS)
CXXFLAGS:=$(CPPFLAGS) $(CXXFLAGS)

# The trailing slashes are very important to the build system
subdirectories:= $(filter-out debian/, $(shell ls -d */))
meryl:= libbio/ libkmer/ libmeryl/ libseq/ libutil/ meryl/

%:
	dh $@ 

override_dh_auto_build:
        # The Makefile apparently doesn't use regular LDFLAGS.
        # It defines CLDFLAGS and CXXLDFLAGS as empty strings, so let's
        # use them here.
	$(MAKE) \
            CLDFLAGS="$(LDFLAGS)" \
            CXXLDFLAGS="$(LDFLAGS)" \
            WITHOUT="$(filter-out $(meryl), $(subdirectories))" install
	ln -sf $(shell uname)-* installdir

override_dh_auto_clean:
	$(MAKE) real-clean
	rm -rf $(shell uname)-* installdir

get-orig-source:
	. debian/get-orig-source

## kmer-tools 0~20150903+r2013

=== debian/changelog ===
kmer-tools (0~20150903+r2013-1) unstable; urgency=low

  * Simplify get-orig-source script
  * Imported Upstream version 0~20150903+r2013
  * Clean up source package: move meryl manpages to a subdirectory of debian/
  * New binary packages:
    - leaff
    - sim4db
  * Drop build-dependency on libbz2-dev
  * Drop kazlib quilt patches
  * Fix section/architecture of the kmer metapackage
  * Set Vcs-Browser to point to cgit
  * Don't install other READMEs to metapackage docs
  * Update d/copyright
  * Update README.source
    - document situation with bundled kazlib
    - document reason for monolithic source package
  * Make the build system more flexible to hopefully fix build on kFreeBSD
  * Add README.Debian to let users know some components aren't yet packaged
  * Add comment for why we can't use dh --parallel

 -- Afif Elghraoui <afif@ghraoui.name>  Sat, 02 Jan 2016 16:49:00 -0800

=== debian/control ===
--- 
+++ 
@@ -3,18 +3,21 @@
 Priority: optional
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Afif Elghraoui <afif@ghraoui.name>
-Build-Depends: debhelper (>= 9),
-	       libbz2-dev
+Build-Depends:
+	debhelper (>= 9),
 Standards-Version: 3.9.6
 Homepage: http://kmer.sourceforge.net
 Vcs-Git: git://anonscm.debian.org/debian-med/kmer-tools.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-med/kmer-tools.git
+Vcs-Browser: http://anonscm.debian.org/cgit/debian-med/kmer-tools.git
 
 Package: kmer
-Architecture: any
-Depends: ${shlibs:Depends},
-	 ${misc:Depends},
-	 meryl
+Section: metapackages
+Architecture: all
+Depends:
+	${misc:Depends},
+	meryl,
+	leaff,
+	sim4db,
 Description: suite of tools for DNA sequence analysis
  The kmer package is a suite of tools for DNA sequence analysis.
  It provides tools for searching (ESTs, mRNAs, sequencing reads);
@@ -41,6 +44,7 @@
 Architecture: any
 Depends: ${shlibs:Depends},
 	 ${misc:Depends}
+Suggests: gridengine-client
 Description: in- and out-of-core kmer counting and utilities
  meryl computes the kmer content of genomic sequences.  Kmer
  content is represented as a list of kmers and the number of
@@ -51,6 +55,8 @@
  report the histogram of counts, the list of kmers and their
  counts, or can perform mathematical and set operations
  on the processed data files.
+ .
+ This package is part of the Kmer suite.
 
 Package: libmeryl-dev
 Architecture: any
@@ -69,3 +75,42 @@
  on the processed data files.
  .
  This package contains the static libraries and header files.
+
+Package: leaff
+Architecture: any
+Depends:
+	${shlibs:Depends},
+	${misc:Depends},
+Description: biological sequence library utilities and applications
+ LEAFF (Let's Extract Anything From Fasta) is a utility program for
+ working with multi-fasta files. In addition to providing random access
+ to the base level, it includes several analysis functions.
+ .
+ This package is part of the Kmer suite.
+
+Package: sim4db
+Architecture: any
+Depends:
+	${shlibs:Depends},
+	${misc:Depends},
+Recommends:
+	leaff,
+Description: batch spliced alignment of cDNA sequences to a target genome
+ Sim4db performs fast batch alignment of large cDNA (EST, mRNA) sequence
+ sets to a set of eukaryotic genomic regions. It uses the sim4 and sim4cc
+ algorithms to determine the alignments, but incorporates a fast sequence
+ indexing and retrieval mechanism, implemented in the sister package
+ 'leaff', to speedily process large volumes of sequences.
+ .
+ While sim4db produces alignments in the same way as sim4 or sim4cc, it
+ has additional features to make it more amenable for use with whole-genome
+ annotation pipelines. A script file can be used to group pairings between
+ cDNAs and their corresponding genomic regions, to be aligned as one run
+ and using the same set of parameters. Sim4db also optionally reports more
+ than one alignment for the same cDNA within a genomic region, as long
+ as they meet user-defined criteria such as minimum length, percentage
+ sequence identity or coverage. This feature is instrumental in finding
+ all alignments of a gene family at one locus. Lastly, the output is
+ presented either as custom sim4db alignments or as GFF3 gene features.
+ .
+ This package is part of the Kmer suite.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# The custom build system doesn't support CPPFLAGS
CFLAGS:=$(CPPFLAGS) $(CFLAGS)
CXXFLAGS:=$(CPPFLAGS) $(CXXFLAGS)

# The trailing slashes are very important to the build system
subdirectories:= $(filter-out debian/, $(shell ls -d */))

# Reference for unusable modules:
# https://lists.debian.org/debian-med/2015/05/msg00075.html
unusable:= tapper/ trie/

# Note: Parallel build is not reliable
%:
	dh $@ 

override_dh_auto_build:
        # The Makefile apparently doesn't use regular LDFLAGS.
        # It defines CLDFLAGS and CXXLDFLAGS as empty strings, so let's
        # use them here.
	$(MAKE) install \
	    CLDFLAGS="$(LDFLAGS)" \
	    CXXLDFLAGS="$(LDFLAGS)"
#	    WITHOUT="$(unusable)"

override_dh_auto_clean:
	$(MAKE) real-clean
	rm -rf installdir

get-orig-source:
	DEB_VERSION_UPSTREAM=$(DEB_VERSION_UPSTREAM) debian/get-orig-source

=== debian/watch ===
# Upstream does not make versioned releases that the watch file can track;
# Sources are retrieved as svn snapshots using the get-orig-source script
